grammar LogProfiler;

@lexer::header {
	package grammar.output;

}
@parser::header {
	package grammar.output;

	import java.util.ArrayList;
	import java.util.Iterator;
	import java.util.List;	
	import java.util.Hashtable;
	import java.util.Collection;
	import java.util.LinkedHashSet;
	import com.totvs.framework.logprofiler.model.ProfilerLogNode;
	import com.totvs.framework.logprofiler.core.ProfilerLog;

}
@parser::members {
	public ProfilerLog ProfilerLog ;
	public String ErroMsg ="";
	public int lineOffset=0;
	
	public ProfilerLog getProfilerLog()
	{
		return ProfilerLog;
	}
	public void setProfilerLog(ProfilerLog pl)
	{
		ProfilerLog = pl;
		lineOffset = ProfilerLog.getLineOffset();
		
	}
	 public void displayRecognitionError(String[] tokenNames,
                                        RecognitionException e) {
               
           //String hdr = getErrorHeader(e);
           String msg = getErrorMessage(e, tokenNames);
            //   "Erro na linha" + String.valueOf(lineOffset);
            
            System.err.println("line:" +String.valueOf(lineOffset +e.line) + " -Error: "+  msg);                         
                                        
    }
	public String getErrorMessage(RecognitionException e,
					String[] tokenNames)
{
	List stack = getRuleInvocationStack(e, this.getClass().getName());
	String msg = null;
	if ( e instanceof NoViableAltException ) {
		NoViableAltException nvae = (NoViableAltException)e;
		msg = " no viable alt; token="+e.token+
			  " (decision="+nvae.decisionNumber+
			  " state "+nvae.stateNumber+")"+
			  " decision=<<"+nvae.grammarDecisionDescription+">>";
	}
	else {
		msg = super.getErrorMessage(e, tokenNames);
	}
	ErroMsg += this.getErrorHeader(e)+" "+msg +"\n";
	return stack+" "+msg;
}
public String getTokenErrorDisplay(Token t) {
	return t.toString();
}
	
	
	
}
stat
@init
{
	ErroMsg = "";
}	:	(call|thread)+ EOF; //begin defines*;
/*
begin loginfo+ 
begin	:	'--- BEGIN APP PROFILER' '(' 'THREAD' '[' INT ']' ')' '----------------------' ;
loginfo	:	
	'[' cparm=ID ':' (xvalue=ID (':\\'ID '.' ID)? |FLOAT)']';
	

defines	:	
		'['X EVERTHING ':' EVERTHING? ']';
		*/
call
@init
{
		ProfilerLogNode CallNode = null;
//		ProfilerFromoNode FromNode
	}	:	
	
		CALL funcname=identifier? (DOT namespace=identifier{
			if(namespace!=null)
			 	funcname += "."+ namespace;
				}
		
		)* (TWODOT mth=identifier)? LPARAM so=source RPARAM C_CHAR  nbcall=numberCalls  tottim=totalTime sl=slower mem=memory?
		{
			if(funcname==null)
				funcname = "Unidentified Internal Call";
			if( so!=null &&  nbcall != null && tottim != null && sl != null)
				{
				CallNode = ProfilerLog.AddCall(funcname+(mth!=null?":"  + mth:""),so,nbcall,tottim,sl);

				}
		}
		
		(thread? from[CallNode]  ) *
		
		;
		
	
from[ProfilerLogNode oCall] 
@init
{
//		ArrayList <ProfilerFromNode> aFroms = new ArrayList<ProfilerFromNode>();

	}
	:	MINUSMINUS FROM cb=cblock? funcname=funcOrMethod? (LPARAM so=source RPARAM)? (LN ln=lineNumber|LPARAM ln=lineNumber RPARAM )
							C_CHAR  NumbCall=numberCalls  tottim=totalTime sl=slower mem=memory?
	{
		String name;
		if( cb != null && cb.sc.length() > 13)
		{
			name=cb.sc.substring(13);
		}
		else
		{
			name=funcname == null? "CodeBlock" : funcname;
		}
		if(oCall != null)
		{
			oCall.addChild(new ProfilerLogNode(name,so,NumbCall,tottim ,sl,ln));
			ProfilerLog.InsertStackCall(funcname,so,NumbCall,tottim ,ln, oCall);
		}
	}
;
cblock returns[String sc]
	:	CODEBLOCK (((OPENC|PIPE|
			ANYCHAR | 
			CLOSEC |
			ID|
			CALL|
			INT|
			FLOAT|			
			INTERNAL|
			TWODOT |
			Thread|
			LPARAM|
			RPARAM|
			LN|
			T_CHAR|
			C_CHAR|
			M_CHAR|
			D_CHAR|			
			STRING|
			STRINGSIMPLE|
			MINOS|
			PLUS|
			DOT
			)+ ENDBLOCK))?
			{
				$sc = $text;

			}
			;
numberCalls returns[String nc]
	:	INT T_CHAR 
		{
		 nc=$INT.text;
		}
	;
lineNumber returns[String nl]
	:	 MINOS ?INT
		{
		 nl=$INT.text;
		}
	;
memory	 returns[String m]
	: D_CHAR (FLOAT
		{
		 m=$FLOAT.text;
		} |INT{
		 m=$INT.text;
		})
		
	;	
totalTime returns[String tt]
	:	FLOAT M_CHAR
	{
		tt = $FLOAT.text;
	}
	;
slower returns[String sl]
	:	FLOAT
		{
		sl = $FLOAT.text;
		}
	;	

funcOrMethod returns[String func]
	:	funcname=identifier 
	(DOT namespace=identifier{
			if(namespace!=null)
			 	funcname += "."+ namespace;
				}
		
		)*
	
	
	 (TWODOT mth=identifier)? // o . ID e para no advtec2 gerar uma funcao statica chamada %nomedofonte.ext%
	{
	func = funcname+(mth!=null?":"  + mth :""); 
	}
	;

source	returns[String sc]
	:	(INTERNAL (ID)?)
		{
			sc="Internal Step";
		}
		| 
		(name=sourceName)
		{
			if(name!=null)
				sc = name;			
		}
		|
		'#DYNAMIC#'
		{
			sc="#DYNAMIC#";
		}
		;
//WorkArround para arquivo com espaco em branco		
sourceName	returns[String sc = new String()]:
		(name=ID{
			if(name!=null)
			 	sc += name.getText();
				}
				|name=INT{
			if(name!=null)
			 	sc += name.getText();
				}
				|name=DOT{
			if(name!=null)
			 	sc += name.getText();
				}
		)+

	;
thread	: timestamp? OPENC Thread INT CLOSEC;

identifier returns[String ident]
	:	ID
		{
		 ident=$ID.text;
		}|'C'{ident="C";}|LN {ident="LN";}|FROM{ident="FROM";}
		|CALL{ident="CALL";}|INTERNAL{ident="INTERNAL";}
	;

timestamp 	:  DATETIME INT PIPE;

  
 
MINUSMINUS : '--'	;
D_CHAR	:	'D';	
M_CHAR 	:	'M';
T_CHAR 	:	'T';
C_CHAR	:	'C';
DOT 	:	'.';	
Thread 	:	'Thread';
FROM 	:	'FROM';
INTERNAL 
	:	'Internal';
CODEBLOCK :  '#CODEBLOCK#';	
ENDBLOCK 
	:	 '}' ']';
LN	:	'LN';
LPARAM 	:	'(';
RPARAM 	:	')';

CALL	:	'CALL';

ID  :	('a'..'z'|'A'..'Z'|'_'|'#'|'%') ('a'..'z'|'A'..'Z'|'0'..'9'|'_'|'-'|'\\'|'#'|'%')*
    ;
PIPE: '|';
TWODOT	:	':';

INT :	'0'..'9'+
    ;
MINOS 	:	'-';
PLUS: '+';
//2020-01-08T18:10:21.582000-02:00 4780|
//2020-11-10T15:20:39.764845+00:00 69
DATETIME 	:  INT MINOS INT MINOS INT 'T'  INT TWODOT  INT  TWODOT  FLOAT (MINOS|PLUS) INT TWODOT INT;
FLOAT
    :   ('0'..'9')+ '.' ('0'..'9')*
    |   '.' ('0'..'9')+ 
    | MINOS ('0'..'9')+ ('.' ('0'..'9')*)? 
    ;
//    |   ('0'..'9')+ 
// (('A'..'Z'|'-')+ ('0'..'9')*)?
  //  ;

WS  :   ( ' '
        | '\t'
        | '\r'
        | '\n'
        ) {$channel=HIDDEN;}
    ;
    STRINGSIMPLE
    :  '\'' (  ~('\''|'\n') )* '\''?
    ;


STRING
    :  '"' ( ~('"'|'\n') )* '"'?
    ;
    
OPENC 	:	 '[';
CLOSEC 	:	']';
ANYCHAR : .; 