grammar LogProfilerCabec;

@lexer::header {
	package grammar.output;

}
@lexer::members {
public void reportError(RecognitionException e){}
}
@parser::header {
	package grammar.output;

	import java.util.ArrayList;
	import java.util.Iterator;
	import java.util.List;	
	import java.util.Hashtable;
	import java.util.Collection;
	import java.util.LinkedHashSet;
	import com.totvs.framework.logprofiler.core.ProfilerLogCabec;


}

@parser::members {
	public ProfilerLogCabec ProfilerLogCabec= new ProfilerLogCabec() ;
	public String ErroMsg = "";
	public ProfilerLogCabec getProfilerLogCabec()

	{
		return ProfilerLogCabec;
	}
	public void reportError(RecognitionException e){}

	public String getErrorMessage(RecognitionException e,
					String[] tokenNames)
{
	List stack = getRuleInvocationStack(e, this.getClass().getName());
	String msg = null;
	if ( e instanceof NoViableAltException ) {
		NoViableAltException nvae = (NoViableAltException)e;
		msg = " no viable alt; token="+e.token+
			  " (decision="+nvae.decisionNumber+
			  " state "+nvae.stateNumber+")"+
			  " decision=<<"+nvae.grammarDecisionDescription+">>";
	}
	else {
		msg = super.getErrorMessage(e, tokenNames);
	}
	ErroMsg += this.getErrorHeader(e)+" "+msg +"\n";
	return stack+" "+msg;
}
public String getTokenErrorDisplay(Token t) {
	return t.toString();
}
}
start	
@init
{
ErroMsg = "";
}
:	('[' statment ']')+ EOF;
//thread	:	ID* 'BEGIN APP PROFILER' '(' 'THREAD' '[' INT ']'')' ID*;
statment:	 	program
		|	job
		|	user
		|	computer
		|	environment
		|	rpodb
		|	localfiles
		|	apo
		|	begin
		|	spent
		|	build
		|	thread
		|	dbthread
		|	stack
		|	memory
		|	peak
		|	conn_ios_in
		|	conn_bytes_in
		|	conn_peakbytes_in
		|	conn_ios_out
		|	conn_bytes_out
		|	conn_peakbytes_out
		|	remark
		|	request
		|	dbapibuild
		|	dbversion
		|	dbarch
		|	dbso

		;

request		:
			'request:'  ID? ID?;
			
job		:	'job:'  ID?
{
	if ($ID.text != null)
		ProfilerLogCabec.program = $ID.text;
};
		

program		:	'program:'  ID
{
	if($ID != null)
		ProfilerLogCabec.program = $ID.text;
	else
		ProfilerLogCabec.program = "n/d";
}
;
user		:	'user:'  ID?
{
	ProfilerLogCabec.user = $ID.text;
}
;
computer	:	'computer:'  ID
{
	ProfilerLogCabec.computer = $ID.text;
}
;
environment	:	'environment:'  ID
{
	ProfilerLogCabec.environment = $ID.text;
}
;
rpodb		:	'rpodb:'  ID
{
	ProfilerLogCabec.rpodb = $ID.text;
}
;
localfiles	:	'localfiles:'  ID?
{
	if($ID != null) 
	ProfilerLogCabec.localfiles = $ID.text;
};
dbapibuild 
	:	'dbapibuild:' ID
	;
dbversion
	:	'dbversion:' ID
	;
dbarch
	:	'dbarch:' ID;
dbso
	:	'dbso:' ID;

apo		
:	'apo:' (windowspath|linuxpath);

windowspath
	:	ID':' (('\\' (ID)+) )+ ;
/*{
@init
{
	String cFullPath = "";
}

//:	'apo:' unidade=ID ':' (('\\' (end1=ID{cFullPath +=end1!=null?end1.getText():""; })+){cFullPath +="\\";})+ 
	cFullPath = unidade.getText() + ":" + "\\" +cFullPath.substring(0,cFullPath.length()-1);//+ "." +ext.getText();
	ProfilerLogCabec.apo = cFullPath;
}
	;*/
linuxpath
	:	(('/'|'\\') ID)+
	;

begin		:	'begin:' dt=datetime
{
	ProfilerLogCabec.begin = dt;
}
;
spent		:	'spent:' tm=time
{
	ProfilerLogCabec.spent = tm;
}
;
build		
@init
{
	//	String cTmp = "";
}
:	'build:' (cTmp=ID ng=ID? ) 
	//'build:' (in=ID '.' {cTmp += in.getText()+".";})* tmp1=ID tmp2=ID
{
	ProfilerLogCabec.build = cTmp.getText(); //+tmp1.getText()+tmp2.getText() ;
}
; 
thread		:	'thread:' ID
{
	ProfilerLogCabec.thread = $ID.text;
}
;
dbthread	:	'dbthread:' ID
{
	ProfilerLogCabec.dbthread = $ID.text;
};
remark	:	REMARK;

/*remark		:	'remark:' ('('ID '/' ID ')' (ID| time |'[' ID ']' | DOTDOTDOT )+ ('(' (ID|time)+ ')') ?  //time ('('  ID  's' ')' )
				   | emp?  logged? obj? (ID ':' ID )*  );*/
stack		:	'stack:' ID 'bytes'
{
	ProfilerLogCabec.stack = $ID.text;
}

;
memory		:	'memory:' ID 'bytes'
{
	ProfilerLogCabec.memory = $ID.text;
};

peak		:	'peak' 'memory:' ID 'bytes'
{
	ProfilerLogCabec.peak = $ID.text;
};

conn_ios_in	:	'conn_ios_in:' ID;
conn_bytes_in	:	'conn_bytes_in:' ID ;
conn_peakbytes_in
	:		'conn_peakbytes_in:' ID?;
conn_ios_out	:	'conn_ios_out:' ID?;
conn_bytes_out	:	'conn_bytes_out:' ID?;
conn_peakbytes_out 
	:		'conn_peakbytes_out:'ID?;	


emp		:	'Emp' ':' (ID) '/' (ID)+;
logged		:	'Logged' ':'  ID ID;
obj		:	'Obj' ':' (ID)*;

datetime returns[String dt] 	:	id1=ID id2=ID id3=ID id4=time id5=ID
{
//	dt = id1.getText()+ " " +id2.getText()+ " " +id3.getText()+" " +id4+ " " +id5.getText();
	dt = id3.getText()+ "/"+ id2.getText()+ "/" +id5.getText()+ " " +id4;
}
;

time returns[String t]	:	i1=ID':' i2=ID':' i3=ID
{
	t = i1.getText()+":"+i2.getText()+":"+i3.getText();
}
;
//rpopath	:	ID ':' (ID|SPECIAL);

ID  :	(LETTER|'_'|'-'|'0'..'9') (LETTER|'0'..'9'|'_'|'-'|'.'|'|')*


    ;

WS  :   ( ' '
        | '\t'
        | '\r'
        | '\n'
        ) {$channel=HIDDEN;}
    ;
fragment
LETTER : ('a'..'z'|'A'..'Z'|'*'|'@') ;

DOTDOTDOT 
	:	'...';
REMARK 	:	   'remark:' ~(']')* ;//'\r'? '\n';


   //CHAR:   (~(']'))+;
/*
CHAR:  '\'' ( ESC_SEQ | ~('\''|'\\') ) '\''
    ;

fragment
EXPONENT : ('e'|'E') ('+'|'-')? ('0'..'9')+ ;

fragment
HEX_DIGIT : ('0'..'9'|'a'..'f'|'A'..'F') ;

fragment
ESC_SEQ
    :   '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\')
    |   UNICODE_ESC
    |   OCTAL_ESC
    ;

fragment
OCTAL_ESC
    :   '\\' ('0'..'3') ('0'..'7') ('0'..'7')
    |   '\\' ('0'..'7') ('0'..'7')
    |   '\\' ('0'..'7')
    ;

fragment
UNICODE_ESC
    :   '\\' 'u' HEX_DIGIT HEX_DIGIT HEX_DIGIT HEX_DIGIT
    ;
*/