grammar LogProfilerCabecWS;

@lexer::header {
	package grammar.output;

}
@parser::header {
	package grammar.output;

	import java.util.ArrayList;
	import java.util.Iterator;
	import java.util.List;	
	import java.util.Hashtable;
	import java.util.Collection;
	import java.util.LinkedHashSet;
	import com.totvs.framework.logprofiler.core.ProfilerLogCabec;


}

@parser::members {
	public ProfilerLogCabec ProfilerLogCabec= new ProfilerLogCabec() ;
	public String ErroMsg = "";
	public ProfilerLogCabec getProfilerLogCabec()

	{
		return ProfilerLogCabec;
	}


	public String getErrorMessage(RecognitionException e,
					String[] tokenNames)
{
	List stack = getRuleInvocationStack(e, this.getClass().getName());
	String msg = null;
	if ( e instanceof NoViableAltException ) {
		NoViableAltException nvae = (NoViableAltException)e;
		msg = " no viable alt; token="+e.token+
			  " (decision="+nvae.decisionNumber+
			  " state "+nvae.stateNumber+")"+
			  " decision=<<"+nvae.grammarDecisionDescription+">>";
	}
	else {
		msg = super.getErrorMessage(e, tokenNames);
	}
	ErroMsg += this.getErrorHeader(e)+" "+msg +"\n";
	return stack+" "+msg;
}
public String getTokenErrorDisplay(Token t) {
	return t.toString();
}
}
start	
@init
{
ErroMsg = "";
}
:	( statment )+ EOF;
//thread	:	ID* 'BEGIN APP PROFILER' '(' 'THREAD' '[' INT ']'')' ID*;
statment:	 	service
		|	method
		|	clientIp
		|	begin
		|	spent
		|	thread
		;

method		:	'Method' pontos  ID?
{
	if ($ID.text != null)
		ProfilerLogCabec.program = $ID.text;
};
		

service		:	'Service' pontos ID
{
	ProfilerLogCabec.program = $ID.text;
}
;
clientIp	:	'Client' 'IP' pontos ID
{
	ProfilerLogCabec.computer = $ID.text;
}
;
pontos	:	
		'.'+ ':';

begin		:	'DateTime'pontos  dt=datetime
{
	ProfilerLogCabec.begin = dt;
}
;
spent		:	'T.Timer' pontos tm=spentTime
{
	ProfilerLogCabec.spent = tm;
}
;
 
thread		:	'Thread' pontos ID
{
	ProfilerLogCabec.thread = $ID.text;
}
	;
datetime returns[String dt] 	:	id1=ID id4=time 
{
//	dt = id1.getText()+ " " +id2.getText()+ " " +id3.getText()+" " +id4+ " " +id5.getText();
	dt = id1.getText()+ " " +id4;
}
;

time returns[String t]	:	i1=ID':' i2=ID':' i3=ID
{
	t = i1.getText()+":"+i2.getText()+":"+i3.getText();
}
;
spentTime returns[String t]	:	i1=ID 's.'
{
	t = i1.getText();
};
//rpopath	:	ID ':' (ID|SPECIAL);

ID  :	(LETTER|'_'|'-'|'0'..'9') (LETTER|'0'..'9'|'_'|'-'|'.')*


    ;

WS  :   ( ' '
        | '\t'
        | '\r'
        | '\n'
        ) {$channel=HIDDEN;}
    ;
fragment
LETTER : ('a'..'z'|'A'..'Z'|''|''|''|''|''|''|''|''|''|''|''|''|'*') ;

   //CHAR:   (~(']'))+;
/*
CHAR:  '\'' ( ESC_SEQ | ~('\''|'\\') ) '\''
    ;

fragment
EXPONENT : ('e'|'E') ('+'|'-')? ('0'..'9')+ ;

fragment
HEX_DIGIT : ('0'..'9'|'a'..'f'|'A'..'F') ;

fragment
ESC_SEQ
    :   '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\')
    |   UNICODE_ESC
    |   OCTAL_ESC
    ;

fragment
OCTAL_ESC
    :   '\\' ('0'..'3') ('0'..'7') ('0'..'7')
    |   '\\' ('0'..'7') ('0'..'7')
    |   '\\' ('0'..'7')
    ;

fragment
UNICODE_ESC
    :   '\\' 'u' HEX_DIGIT HEX_DIGIT HEX_DIGIT HEX_DIGIT
    ;
*/