@echo off
color 0A
REM # #############################################################################################
REM # STARTPROTHEUS12.bat PRODUÇÃO
REM #
REM # DESCRICAO:
REM # Este script inicia todos os serviços do Protheus 12
REM # Data: 29-04-2024
REM # Autor: SPHELP - SITE - https://sphelp.com.br/ 
REM #############################################################################################

@echo off
@echo ACESSO ADMINISTRATIVO SPHELP
setlocal enabledelayedexpansion
set "servicos_ok="
set "servicos_falha="
set "log_file=log_startprotheus12.txt"

REM ########## FUNÇÃO PARA CONTAR LINHAS
set /a count_lines=0
for /f %%a in ('find /c /v "" ^< %log_file%') do set /a count_lines=%%a

:inicio
cls
echo Deseja continuar? (S/N):
set /p resposta=
if /i "!resposta!"=="S" (
    echo INICIO TOTAL DO PROTHEUS PRODUCAO...



    REM ########## LICENSE SERVER
    @echo ON
    @echo INICIANDO O LICENSE SERVER
    sc \\10.10.69.176 start "licenseVirtual"
    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!LICENSE SERVER\n"
    ) else (
        set "servicos_falha=!servicos_falha!LICENSE SERVER\n"
    )

timeout /t 5 /nobreak >nul

    REM ########## DBACCESS
    @echo ON
    @echo INICIANDO O DBACCESS
    sc \\10.10.69.176 start "DBACCESS-PRD"
    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!DBACCESS\n"
    ) else (
        set "servicos_falha=!servicos_falha!DBACCESS\n"
    )
    sc \\10.10.69.176 start "DBACCESS-PRD-TSS"
    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!DBACCESS-TSS\n"
    ) else (
        set "servicos_falha=!servicos_falha!DBACCESS-TSS\n"
    )

    REM ########## APPSERVER - 10.10.69.177 - 178 - 179 - 121
    @echo ON
    @echo INICIANDO OS APPSERVER SENCUNDARIOS
	
	
	sc \\10.10.69.177 start "TOTVS-PRD-P12-SLV01_177A"
	    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV01_177A\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV01_177A\n"
    )
	
    sc \\10.10.69.177 start "TOTVS-PRD-P12-SLV02_177B"
	    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV02_177B\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV02_177B\n"
    )
	
    sc \\10.10.69.177 start "TOTVS-PRD-P12-SLV03_177C"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV03_177C\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV03_177C\n"
    )
	
    sc \\10.10.69.177 start "TOTVS-PRD-P12-SLV04_177D"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV04_177D\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV04_177D\n"
    )
	
    sc \\10.10.69.177 start "TOTVS-PRD-P12-SLV05_177E"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV05_177E\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV05_177E\n"
    )
	
    sc \\10.10.69.178 start "TOTVS-PRD-P12-SLV01_178A"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV01_178A\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV01_178A\n"
    )
	
    sc \\10.10.69.178 start "TOTVS-PRD-P12-SLV02_178B"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV02_178B\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV02_178B\n"
    )
	
    sc \\10.10.69.178 start "TOTVS-PRD-P12-SLV03_178C"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV03_178C\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV03_178C\n"
    )
	
    sc \\10.10.69.178 start "TOTVS-PRD-P12-SLV04_178D"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV04_178D\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV04_178D\n"
    )
	
    sc \\10.10.69.178 start "TOTVS-PRD-P12-SLV05_178E"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV05_178E\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV05_178E\n"
    )
	
    sc \\10.10.69.179 start "TOTVS-PRD-P12-SLV01_179A"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV01_179A\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV01_179A\n"
    )
	
    sc \\10.10.69.179 start "TOTVS-PRD-P12-SLV02_179B"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV02_179B\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV02_179B\n"
    )
	
    sc \\10.10.69.179 start "TOTVS-PRD-P12-SLV03_179C"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV03_179C\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV03_179C\n"
    )
	
    sc \\10.10.69.179 start "TOTVS-PRD-P12-SLV04_179D"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV04_179D\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV04_179D\n"
    )
	
    sc \\10.10.69.179 start "TOTVS-PRD-P12-SLV05_179E"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV05_179E\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV05_179E\n"
    )
	
    sc \\10.10.69.121 start "TOTVS-PRD-P12-SLV01_121A"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV01_121A\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV01_121A\n"
    )
	
    sc \\10.10.69.121 start "TOTVS-PRD-P12-SLV02_121B"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV02_121B\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV02_121B\n"
    )
	
    sc \\10.10.69.121 start "TOTVS-PRD-P12-SLV03_121C"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV03_121C\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV03_121C\n"
    )
	
    sc \\10.10.69.121 start "TOTVS-PRD-P12-SLV04_121D"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV04_121D\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV04_121D\n"
    )
	
    sc \\10.10.69.121 start "TOTVS-PRD-P12-SLV05_121E"
		    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SLV05_121E\n"
    ) else (
        set "servicos_falha=!servicos_falha!SLV05_121E\n"
    )
	
	REM ########## BROKER ERP - HTTP WEBAPP
    @echo ON
    @echo INICIANDO O BROKER ERP E HTTP WEBAPP
    sc \\10.10.69.166 start ".TOTVS_BROKER-ERP_PRD"
    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!BROKER ERP\n"
    ) else (
        set "servicos_falha=!servicos_falha!BROKER ERP\n"
    )
    sc \\10.10.69.166 start ".TOTVS_BROKER_HTTP"
    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!BROKER HTTP\n"
    ) else (
        set "servicos_falha=!servicos_falha!BROKER HTTP\n"
    )

    REM ########## SCHEDULE
    @echo ON
    @echo INICIANDO O SCHEDULE
    sc \\10.10.69.164 start ".TOTVS-SCH01-prd-P12"
    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!SCHEDULE\n"
    ) else (
        set "servicos_falha=!servicos_falha!SCHEDULE\n"
    )

    REM ########## TSS
    @echo ON
    @echo INICIANDO O TSS
    sc \\10.10.69.183 start "TOTVS-TSS-PRD-P12 12.1.07"
    if not errorlevel 1 (
        set "servicos_ok=!servicos_ok!TSS\n"
    ) else (
        set "servicos_falha=!servicos_falha!TSS\n"
    )

    REM ########## LOG
    echo. >> %log_file%
    echo %date% %time% >> %log_file%
    echo --- SERVIÇOS INICIADOS COM SUCESSO --- >> %log_file%
    echo %servicos_ok% >> %log_file%
    echo. >> %log_file%
    echo --- SERVIÇOS COM FALHA AO INICIAR --- >> %log_file%
    echo %servicos_falha% >> %log_file%

) else if /i "!resposta!"=="N" (
    echo Saindo...
    exit
) else (
    set "resposta="
    echo.
    echo Por favor, digite apenas S ou N.
    timeout /t 1 >nul
    goto inicio
)
