# Logo SPHELP
Write-Output "  SSS   PPPP   H   H  EEEEE  L     PPPP   "
Write-Output " S      P   P  H   H  E      L     P   P  "
Write-Output "  SSS   PPPP   HHHHH  EEEE   L     PPPP   "
Write-Output "     S  P      H   H  E      L     P      "
Write-Output " SSSS   P      H   H  EEEEE  LLLLL  P      "
Write-Output "                                          "
Write-Output ""

# Obter informacoes do processador usando WMI
$cpu_info = Get-WmiObject Win32_Processor | Select-Object Name, NumberOfCores, NumberOfLogicalProcessors, MaxClockSpeed

# Exibir as informações do processador
Write-Host "Informacoes do Processador:"
Write-Host "- Nome: $($cpu_info.Name)"
Write-Host "- Nucleos: $($cpu_info.NumberOfCores)"
Write-Host "- Threads: $($cpu_info.NumberOfLogicalProcessors)"
Write-Host "- Clock Maximo: $($cpu_info.MaxClockSpeed) MHz"
Write-Output ""

# Verificar se o clock é menor que 2300MHz (2.3GHz)
$min_clock = 2300
if ($cpu_info.MaxClockSpeed -lt $min_clock) {
    Write-Output "****************************************************************************"
    Write-Output "*                                                                          *"
    Write-Output "*   >>>>>> ATENCAO <<<<<<                                                  *"
    Write-Output "*                                                                          *"
    Write-Output "*   Processador invalido para uso do Protheus (Clock minimo de 2.3GHz).    *"
    Write-Output "*   Este processador nao atende aos requisitos minimos para o Protheus,    *"
    Write-Output "*   que exige um clock mínimo de 2.3GHz, conforme comprovado por estudo de *"
    Write-Output "*   desempenho, feito pela TOTVS.                                          *"
    Write-Output "*                                                                          *"
    Write-Output "*   >>>>>> ATENCAO <<<<<<                                                  *"
    Write-Output "****************************************************************************"
} else {
    Write-Output "***************************************************"
    Write-Output "*                                                 *"
    Write-Output "*   >>>>>> SPHELP <<<<<<                          *"
    Write-Output "*                                                 *"
    Write-Output "*   Processador adequado para uso do Protheus.    *"
    Write-Output "*                                                 *"
    Write-Output "*   >>>>>> SPHELP <<<<<<                          *"
    Write-Output "***************************************************"
}
